ObjC.import('Cocoa');

console.log('Fetching notes...');

function textForNoteWithHTML(html) {
    var text = html;
    
    // replace list items with dashes and spaces
    text = text.replace(/<li>/g, '- ');
    
    var allTagsRegex = /<(\/?)(\w+)[^>]*(\/?)>/g;
    text = text.replace(allTagsRegex, '');
    
    return text;
}

function attachmentReferencesForNoteWithAttachments(attachments, path) {
    var refs = [];
    
    for (var i = 0; i < attachments.length; i++) {
        var a = attachments[i];
        var ref = {};
        ref.id = a.id();
        ref.name = a.name();
        refs.push(ref);
        ref.filename = ref.name;
        // if we have a path, save to disk
        if (path) {
            refPath = path + '/' + ref.filename;
            console.log(refPath);
            var saveParams = {};
            saveParams.in = refPath;
            saveParams.as = 'native format';
            a.save(saveParams);
        }
    }
    
    return refs;
}

function jsonForNote(note, path) {
    var obj = {};
    obj.html = note.body();
    obj.text = textForNoteWithHTML(note.body());
    obj.id = note.id();
    obj.creationDate = note.creationDate();
    obj.modificationDate = note.modificationDate();
    
    var attachments = note.attachments();
    if (attachments && attachments.length > 0) {
        obj.attachments = attachmentReferencesForNoteWithAttachments(attachments, path);
    }
    
    return obj;
}

var outputPath = '{{outputPath}}';
var outputFile = outputPath + '/noteAppNotes.json';
console.log(outputFile);

var notesApp = Application('Notes');
var notes = notesApp.notes;
var jsonObjects = [];
for (var i = 0; i < notes.length; i++) {
    var obj = jsonForNote(notes[i], outputPath);
    if (obj) {
        jsonObjects.push(obj);
    }
}

var jsonString = JSON.stringify(jsonObjects, null, '  ')

output = $.NSString.alloc.initWithUTF8String(jsonString);
output.writeToFileAtomically(outputFile, true);


